//-----------------------------------------------------------------------
//	Module:		N64
//	Desc:		
//			The format of the ButtonStatus bus is as follows:
//			BitRange	Button
//			29		A
//			28		B
//			27		Z
//			26		Start
//			25:22		D-Pad
//				25		Up
//				24		Down
//				23		Left
//				22		Right
//			21		L
//			20		R
//			19:16		C-Arrows
//				19		Up
//				18		Down
//				17		Left
//				16		Right
//			15:0		Analog Joystick
//				15:8		Left/Center/Right (-/0/+)
//				7:0		Up/Center/Down (+/0/-)
//-----------------------------------------------------------------------
module	N64(N64_DQ,
            Clock,
            Reset,
            ButtonStatus);

    inout N64_DQ;
    
    input Clock;
    input Reset;

    output [29:0] ButtonStatus;

    wire N64En;

    N64bb MyN64bb(  .N64_DQ(N64_DQ),
                    .Clock(Clock),
                    .Reset(Reset),
                    .ButtonStatus(ButtonStatus),
                    .N64En(N64En));
    
    assign N64_DQ = N64En ? 0 : 1'bZ;

endmodule
//-----------------------------------------------------------------------