module N64ButtonParser( Clock,
                        Reset,
                        ButtonStatus,
                        A,
                        B,
                        Z,
                        Start,
                        DU,
                        DD,
                        DL,
                        DR,
                        L,
                        R,
                        CU,
                        CD,
                        CL,
                        CR,
                        Joystick);

    input           Clock;
    input           Reset;

    input   [29:0]  ButtonStatus;

    output          A;
    output          B;
    output          Z;
    output          Start;
    output          DU;
    output          DD;
    output          DL;
    output          DR;
    output          L;
    output          R;
    output          CU;
    output          CD;
    output          CL;
    output          CR;
    output  [15:0]  Joystick;

    reg     [13:0]  ButtonStatusDelayed;

    always @(posedge Clock)
        if(Reset) ButtonStatusDelayed <= 14'b11111111111111;
        else ButtonStatusDelayed <= ButtonStatus[29:16];

    assign {A,B,Z,Start,DU,DD,DL,DR,L,R,CU,CD,CL,CR} = ~ButtonStatusDelayed & ButtonStatus[29:16];
    assign Joystick = ButtonStatus[15:0];

endmodule
